# -*- coding: utf-8 -*-

# Copyright (C) 2012-2013 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
# Copyright (C) 2012-2013 by Oleksandr Shneyder <oleksandr.shneyder@obviously-nice.de>
#
# X2Go Session Broker is free software; you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# X2Go Session Broker is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

"""\
L{zeroconf.X2GoBroker} class - a demo X2GoBroker implementations that needs not configuration at all

"""
__NAME__ = 'x2gobroker-pylib'

# modules
import uuid

# Python X2GoBroker modules
import base_broker as base

class X2GoBroker(base.X2GoBroker):

    backend_name = 'zeroconf'

    def list_profiles(self, username):

        _list_of_profiles = {
            uuid.uuid4(): {
                'user': u'',
                'defsndport': True,
                'useiconv': False,
                'iconvfrom': u'UTF-8',
                'height': 600,
                'export': u'',
                'quality': 9,
                'fullscreen': False,
                'layout': u'',
                'useexports': 1,
                'width': 800,
                'speed': 2,
                'soundsystem': u'pulse',
                'print': True,
                'type': u'auto',
                'sndport': 4713,
                'xinerama': True,
                'variant': u'',
                'usekbd': True,
                'fstunnel': True,
                'applications': [u'TERMINAL',u'WWWBROWSER',u'MAILCLIENT',u'OFFICE',],
                'host': u'localhost',
                'multidisp': 0,
                'sshproxyport': 22,
                'sound': True,
                'rootless': 0,
                'name': u'LOCALHOST',
                'iconvto': u'UTF-8',
                'soundtunnel': True,
                'command': self.get_backend_value(self.backend_name, u'desktop-shell'),
                'dpi': 96,
                'sshport': 22,
                'setdpi': 0,
                'pack': u'16m-jpeg',
            },
        }
        list_of_profiles = {}
        for profile_id in _list_of_profiles.keys():
            profile = self.get_profile_defaults()
            profile.update(_list_of_profiles[profile_id])
            list_of_profiles[profile_id] = profile
        return list_of_profiles

    def select_session(self, profile_id, username=None):

        selectprofile_output = {
            'server': 'localhost',
            'port': 22,
        }
        return selectprofile_output
